---
Title: Research
Description: A list of my research Projects
---

[Quick List of Publications](publications)

## Computer Science / Data Science Research

### Reinforcement Learning

**Deep Reinforcement Learning:** With Dr. Ron Zacharski I focused more on a particular instance of Reinforcement Learning where deep neural networks are used. During this time, I built out a Reinforcement Learning library written in PyTorch. This library helps me have a test bed for trying out different algorithms and attempts to create my own.

One particular problem I'm fascinated by is how to make Reinforcement Learning algoirthms more sample efficient. This means, how can we make it so that it learns more from every observation or make it so that we can achieve our goal quicker?

[RL Library on Github](https://github.com/brandon-rozek/rltorch)

[Interactive Demonstrations Library](https://github.com/brandon-rozek/gyminteract)

[Honors Thesis](/files/research/honorsthesis.pdf)

[Honors Defense](/files/research/ExpeditedLearningInteractiveDemo.pptx)

[QEP Algorithm Slides](/files/research/QEP.pptx)

[More...](deepreinforcementlearning)

**Reinforcement Learning:** Studied the fundamentals of reinforcement learning with Dr. Stephen Davies. We went over the fundamentals such as value functions, policy functions, how we can describe our environment as a markov decision processes, etc.

[Notes and Other Goodies](reinforcementlearning)

[Github Code](https://github.com/brandon-rozek/ReinforcementLearning)


### Symbolic Methods
Worked with Dr. Andrew Marshall under an ONR grant in collaboration with University at Albany, Clarkson University, and the Naval Research lab in order to automatically generated and verify cryptographic algorithms.

During that time period I built a free algebra library, rewrite library, parts of the crypto tool, and dabbled in Unification algorithms. We're hoping to open source the code base by 2021. (Ping me if its past due)

Currently I'm an external collaborator focused on strengthing the rewrite library. My dream is to slowly work towards building an easy to use theorem prover.

### Programming Languages

Studying the design of programming languages. So far I made an implementation of the SLOTH programming language, experimenting with what I want my own programming language to be syntatically and paradigm wise.

[SLOTH Code](https://github.com/brandon-rozek/SLOTH)

Before this study, I worked though a book called "Build your own Lisp" and my implementation of a lisp like language is below.

[Lispy Code](https://github.com/brandon-rozek/lispy)

### Other

**Competitive Programming:** Studying algorithms and data structures necessary for competitive programming. Attended ACM ICPC in November 2018/2019 with a team of two other students.

## Math/Statistics Research

Worked on an independent study on the topic of **Cluster Analysis**. This is where you try to group similar observations without knowing what the labels are.
I studied under the guidance of Dr. Melody Denhere, the link below gives you more of a description of the project along with my course notes.

[Cluster Analysis Spring 2018](clusteranalysis)

## Physics Research

For the two projects below, I worked on Quantum Research in a physics lab with a fellow student Hannah Killian and an advisor Dr. Hai Nguyen. I mostly assisted with the software support for the project and assisted in the mathematics in whatever way I can.

[Modeling Population Dynamics of Incoherent and Coherent Excitation](/files/research/modellingpopulationdynamics.pdf)

[Coherent Control of Atomic Population Using the Genetic Algorithm](/files/research/coherentcontrolofatomicpopulation.pdf)


In order to circumvent the frustrations I had with simulation code taking a while, I applied and received funding to build out a Beowulf cluster for the Physics department. Dr. Maia Magrakvilidze was the advisor for this project.

[High Performance Cluster for Research and Education Report (nicknamed LUNA-C)](/files/research/LUNAC.pdf)

[LUNA-C Poster](/files/research/LUNACposter.pdf)

